//****************************//
//                            //
//  MailSender Ver:sample     //
//  Copyright: Sam Zhao       //
//  2005 Niigata City Japan   //
//                            //
//****************************//
using System;
//FileInfo,FileStream
using System.IO;
//Dns
using System.Net;
//Encoding
using System.Text;
//ԂpŎ擾邽߂
using System.Globalization;

namespace MailSender
{
	/// <summary>
	/// MyMail ̊Tv̐łB
	/// </summary>
	public class MyMail
	{
		string CRLF = "\r\n";
		string boundaryStr = "NextPart_Email_Sender";
		public MyMail()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}
		/// <summary>
		/// bZ[WFrom
		/// </summary>
		private string from = "anonymous@example.com";
		public string From
		{
			get{return from;}
			set{from = value;}
		}

		/// <summary>
		/// bZ[WTo
		/// </summary>
		private string to = "anonymous@example.com";
		public string To
		{
			get{return to;}
			set{to = value;}
		}

		/// <summary>
		/// bZ[WCC
		/// CCwb_邩ǂaddCcŃ`FbN
		/// </summary>
		private bool addCc = false;
		public bool AddCc
		{
			get{return addCc;}
			set{addCc = value;}
		}
		private string cc = "anonymous@example.com";
		public string Cc
		{
			get{return cc;}
			set{cc = value;}
		}

		/// <summary>
		/// bZ[W̌
		/// </summary>
		private string subject = "No Subject";
		public string Subject
		{
			get{return subject;}
			set{subject = value;}
		}

		/// <summary>
		/// Ytt@CL
		/// </summary>
		private bool haveAttachment = false;
		public bool HaveAttachment
		{
			get{return haveAttachment;}
			set{haveAttachment = value;}
		}
		private string[] attachments = null;
		public string[] Attachments
		{
			get{return attachments;}
			set{attachments = value;}
		}

		/// <summary>
		/// bZ[W{
		/// </summary>
		private string messageBody = "";
		public string MessageBody
		{
			get{return messageBody;}
			set{messageBody = value;}
		}

		/// <summary>
		/// bZ[W\
		/// </summary>
		/// <returns></returns>
		public string BuildMessage()
		{
			StringBuilder msg = new StringBuilder();
            
			msg.Append("From: " + from + CRLF);
			msg.Append("To: " + to + CRLF);
			if(addCc)
			{
				msg.Append("Cc: " + cc + CRLF);
			}
			msg.Append("Subject: " + TransTextTo64(subject) + CRLF);
			msg.Append("Date: " + DateTime.Now.ToString("ddd, dd MMM yyyy HH:mm:ss +0900",
				new CultureInfo("en-US")) + CRLF);
			msg.Append("X-Mailer: C# Email Sender" + CRLF);
			msg.Append("MIME-Version: 1.0" + CRLF);

			if(haveAttachment)
			{

				msg.Append("Content-Type: multipart/mixed; boundary=\"" + boundaryStr +"\"" + CRLF);
				msg.Append(CRLF);
				msg.Append("This is a multi-part message in MIME format." + CRLF);
				msg.Append(CRLF);
				msg.Append("--" + boundaryStr + CRLF);
				msg.Append("Content-Type: text/plain; charset=\"iso-2022-jp\"" + CRLF);
				msg.Append("Content-Transfer-Encoding: 7bit" + CRLF);
				msg.Append(CRLF);
				msg.Append(MsgBodyTo7bit(messageBody) + CRLF);
				foreach(string filePath in attachments)
				{
					string fileName = "";
					string [] fileNames = filePath.Split('\\');
					fileName = fileNames[fileNames.Length-1];
					msg.Append("--" + boundaryStr + CRLF);
					msg.Append("Content-Type: " + ContentType(fileName) + "; name=\"" + TransTextTo64(fileName) + "\""+ CRLF);
					msg.Append("Content-Transfer-Encoding: base64" + CRLF);
					msg.Append("Content-Disposition: attachment; filename=\"" + TransTextTo64(fileName) + "\"" + CRLF);
					msg.Append(CRLF);
					msg.Append(AttachStr(filePath));
					msg.Append(CRLF);
				}
				msg.Append("--" + boundaryStr + "--");
			}
			else
			{
				msg.Append("Content-Type: text/plain; charset=\"iso-2022-jp\"" + CRLF);
				msg.Append("Content-Transfer-Encoding: 7bit" + CRLF);
				msg.Append(CRLF);
				msg.Append(MsgBodyTo7bit(messageBody) + CRLF);
			}

			return msg.ToString();
		}
		/// <summary>
		/// bZ[W{7bitɕϊ
		/// </summary>
		/// <param name="body"></param>
		/// <returns></returns>
		private string MsgBodyTo7bit(string body)
		{
			Encoding encode = Encoding.GetEncoding("iso-2022-jp");
			byte[] bb = encode.GetBytes(body);
			return Encoding.Default.GetString(bb,0,bb.Length);
		}
		/// <summary>
		/// t@Cbase64ɕϊ
		/// </summary>
		/// <param name="sourceStr"></param>
		/// <returns></returns>
		private string TransTextTo64(string sourceStr)
		{
			Encoding encode = Encoding.GetEncoding("iso-2022-jp");
			byte[] bb = encode.GetBytes(sourceStr);
			string ss = Convert.ToBase64String(bb,0,bb.Length);
			ss = "=?iso-2022-jp?B?" + ss + "?=";
			return ss;
		}
		/// <summary>
		/// gqt@C^Cv𔻖
		/// </summary>
		/// <param name="abc"></param>
		/// <returns></returns>
		private string ContentType(string fileName)
		{
			string[] ss = fileName.Split('.');
			string abc = ss[ss.Length-1];
			string type = "";
			switch(abc)
			{
				case "txt":
					type = "text/plain";
					break;
				case "jpg":
					type = "Image/jpeg";
					break;
				case "gif":
					type = "Image/gif";
					break;
				case "wav":
					type = "Audio/wav";
					break;
				case "doc":
					type = "application/msword";
					break;
				case "mdb":
					type = "application/msaccess";
					break;
				case "ppt":
					type = "application/vnd.ms-powerpoint";
					break;
				case "xls":
					type = "application/vnd.ms-excel";
					break;
				default:
					type = "application/octet-stream";
					break;
			}
			return type;
		}
		/// <summary>
		/// Ytt@Cbase64ɕϊ
		/// </summary>
		/// <param name="filePath"></param>
		/// <returns></returns>
		private string AttachStr(string filePath)
		{
			FileInfo fileInfo = new FileInfo(filePath);
			long fileLength = fileInfo.Length;
			FileStream fs = new FileStream(filePath,FileMode.Open);
			byte[] bb = new byte[fileLength];
			fs.Read(bb,0,(int)fileLength);
			string ss = Convert.ToBase64String(bb,0,bb.Length);
			int index = 0;
			StringBuilder sb = new StringBuilder();
			while(index < ss.Length)
			{
				sb.Append(ss[index]);
				index ++;
				if(index % 76 == 0)
				{
					sb.Append(CRLF);
				}
			}
			fs.Close();
			return sb.ToString();
		}
	}
}
